// > *** MoReFEM Doxygen information and copyright notice *** //
/*!
 * This file is part of the [MoReFEM](https://gitlab.inria.fr/MoReFEM/CoreLibrary/MoReFEM) library.
 * It is released under the LGPL v3 license; a copy is provided in the LICENSE file shipped with it.
 *
 * MoReFEM is mostly developed by [M3DISIM team-project](https://www.inria.fr/m3disim).
 * You may contact its developers by writing at morefem-maint@inria.fr.
 *
 * \file
 *
 * \ingroup TestGroup
 * \addtogroup TestGroup
 * @{
 */
// *** MoReFEM Doxygen information and copyright notice *** < //

/*!
// \file
//
//
 on the Thu, 5 Mar 2020 14:30:17 +0100
// Copyright (c) Inria. All rights reserved.
//
*/

#include <cassert>
#include <cstddef> // IWYU pragma: keep
#include <cstdlib>

#include "Utilities/LinearAlgebra/Type.hpp"

#include "Test/Operators/VariationalInstances/QuasiIncompressiblePk2/ExpectedResults.hpp"

// NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

namespace MoReFEM::TestNS::QuasiIncompressiblePk2
{


    namespace // anonymous
    {


        expected_results_type<LinearAlgebraNS::type::matrix> Matrix3D();
        expected_results_type<LinearAlgebraNS::type::matrix> Matrix2D();
        expected_results_type<LinearAlgebraNS::type::matrix> Matrix1D();
        expected_results_type<LinearAlgebraNS::type::vector> Vector3D();
        expected_results_type<LinearAlgebraNS::type::vector> Vector2D();
        expected_results_type<LinearAlgebraNS::type::vector> Vector1D();


    } // namespace


    expected_results_type<LinearAlgebraNS::type::matrix>
    GetExpectedMatrixP1bP1(::MoReFEM::GeometryNS::dimension_type dimension)
    {
        switch (dimension.Get())
        {
        case 3:
            return Matrix3D();
        case 2:
            return Matrix2D();
        case 1:
            return Matrix1D();
        default:
            assert(false && "Invalid case!");
            exit(EXIT_FAILURE);
        }
    }


    expected_results_type<LinearAlgebraNS::type::vector>
    GetExpectedVectorP1bP1(::MoReFEM::GeometryNS::dimension_type dimension)
    {
        switch (dimension.Get())
        {
        case 3:
            return Vector3D();
        case 2:
            return Vector2D();
        case 1:
            return Vector1D();
        default:
            assert(false && "Invalid case!");
            exit(EXIT_FAILURE);
        }
    }

    // NOLINTBEGIN(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers,readability-function-cognitive-complexity,modernize-use-std-numbers)
    namespace // anonymous
    {


        expected_results_type<LinearAlgebraNS::type::matrix> Matrix3D()
        {
            return expected_results_type<LinearAlgebraNS::type::matrix>

                { { 7.6914959186790145e+02,
                    -6.3841031380805603e+01,
                    -1.7039566315702643e+02,
                    -5.5138682800159912e-02,
                    -2.5679292658105834e+02,
                    6.5639149636917898e+02,
                    5.5702452003897315e+02,
                    -3.5058820929210713e-02,
                    -1.0259335580872071e+03,
                    -8.8034504733628273e+02,
                    1.5159709189407729e+02,
                    -4.7757233627623380e-02,
                    -1.5999383815343081e+03,
                    -6.3182414070540403e+01,
                    -6.2715785002253608e+02,
                    -4.7757233627623311e-02,
                    2.1135152743346721e+03,
                    3.5097699641844963e+02,
                    8.8931901246512169e+01 },
                  { -6.3841031380807124e+01,
                    4.9398919455252252e+02,
                    -2.5470637711797266e+02,
                    -5.5138682800159780e-02,
                    -9.2444804955078814e+02,
                    -1.9672823787277451e+00,
                    1.0093302312126121e+02,
                    -4.7757233627623401e-02,
                    9.0417114949245843e+02,
                    -5.1074338573635856e+02,
                    6.9957829182510932e+02,
                    -3.5058820929210519e-02,
                    -6.9317578157250637e-01,
                    -6.4892689749554734e+02,
                    -4.7684438133997418e+02,
                    -4.7757233627623158e-02,
                    8.4811107220709431e+01,
                    6.6764837105811125e+02,
                    -6.8960556488423549e+01 },
                  { -1.7039566315703090e+02,
                    -2.5470637711798378e+02,
                    3.0160520059038191e+02,
                    -5.5138682800159669e-02,
                    -9.5355020349242943e+02,
                    3.1252823841975378e+01,
                    1.1465831210957742e+02,
                    -4.7757233627623373e-02,
                    1.4334147869139963e+02,
                    -7.3811163431019304e+02,
                    -3.7721758958587571e+01,
                    -4.7757233627623200e-02,
                    1.1947488000874171e+03,
                    1.0716947771021705e+03,
                    -6.7855909888667668e+02,
                    -3.5058820929210373e-02,
                    -2.1414441212935679e+02,
                    -1.1012958951596903e+02,
                    3.0001734514530483e+02 },
                  { -4.1560029791070185e+01,
                    -4.0388735748394673e+01,
                    -3.9191797842222833e+01,
                    1.6666666666666670e-07,
                    -1.6712239387563224e+02,
                    3.4091128179341766e+01,
                    2.6909500742311334e+01,
                    8.3333333333333365e-08,
                    8.2678922226464564e+01,
                    -1.3376142238329012e+02,
                    6.6101298584534462e+01,
                    8.3333333333333365e-08,
                    1.2423895201753493e+02,
                    1.1486859967613159e+02,
                    -1.0294818988426952e+02,
                    8.3333333333333378e-08,
                    1.7645494227029697e+00,
                    2.5190430276211391e+01,
                    4.9129188399646559e+01 },
                  { -2.5679292658105840e+02,
                    -9.2444804955078826e+02,
                    -9.5355020349242886e+02,
                    -2.4936908983865122e-01,
                    5.2710857431811146e+03,
                    -4.1746885754511675e+02,
                    -5.1393948115856392e+02,
                    -2.6872876759711006e-01,
                    2.3336989620062395e+03,
                    -2.8162479047647939e+03,
                    1.5278418461061456e+03,
                    -1.6714146600980881e-01,
                    2.3334426970949626e+03,
                    2.3614905403216003e+03,
                    -1.7266462431860441e+03,
                    -1.4174464061298286e-01,
                    -9.6814344757012586e+03,
                    1.7966742715390983e+03,
                    1.6662940817308913e+03 },
                  { 6.5639149636917682e+02,
                    -1.9672823787318237e+00,
                    3.1252823841974124e+01,
                    4.0731503481153987e-02,
                    -4.1746885754511868e+02,
                    4.7937308044272013e+03,
                    -1.1040971406445767e+03,
                    4.7002555179553207e-02,
                    2.3335870571714131e+03,
                    1.3058708128015280e+03,
                    -9.6698970157738904e+02,
                    -1.6489508312510320e-02,
                    -2.5782644241995249e+03,
                    1.7128545378154913e+03,
                    1.7906176333350265e+02,
                    7.2399380576378763e-02,
                    5.7547282040534355e+00,
                    -7.8104888726654899e+03,
                    1.8607722550464887e+03 },
                  { 5.5702452003897145e+02,
                    1.0093302312125925e+02,
                    1.1465831210957843e+02,
                    4.0731503481154327e-02,
                    -5.1393948115856517e+02,
                    -1.1040971406445756e+03,
                    3.5765122199102261e+03,
                    4.7002555179553318e-02,
                    -1.7941879339208488e+03,
                    4.1632968301401695e+02,
                    1.0614055426837565e+03,
                    5.9700967877966353e-02,
                    1.3004755912466308e+03,
                    -1.1558937640061549e+03,
                    9.0995185644239507e+02,
                    -3.7910956140976074e-03,
                    4.5062730379381139e+02,
                    1.7427281985154546e+03,
                    -5.6625279311459572e+03 },
                  { -3.3100466667744890e+01,
                    -4.4621311915248405e+01,
                    -4.4086318753311538e+01,
                    8.3333333333333365e-08,
                    -2.3505294756525913e+02,
                    5.0899997705626298e+01,
                    4.7690038734005171e+01,
                    1.6666666666666665e-07,
                    1.4875392888349868e+01,
                    -1.2130656416498940e+02,
                    9.1776357487316830e+01,
                    8.3333333333333365e-08,
                    4.7975859556094775e+01,
                    1.4014262153612327e+02,
                    -8.0965197545235881e+01,
                    8.3333333333333365e-08,
                    2.0530216178855937e+02,
                    -2.5114743161511800e+01,
                    -1.4414879922774599e+01 },
                  { -1.0259335580872050e+03,
                    9.0417114949246138e+02,
                    1.4334147869140807e+02,
                    9.5870186281313940e-02,
                    2.3336989620062400e+03,
                    2.3335870571714140e+03,
                    -1.7941879339208476e+03,
                    5.8708999182876306e-03,
                    8.8553033387626001e+03,
                    -8.3699220375647576e+02,
                    -6.0952926077086602e+02,
                    1.0745820150558943e-01,
                    6.1335852618860481e+03,
                    -2.8285232182148284e+03,
                    1.0052723660904614e+03,
                    1.2015661420400191e-01,
                    -1.6296654004567685e+04,
                    4.2775721530742896e+02,
                    1.2551033499098442e+03 },
                  { -8.8034504733628364e+02,
                    -5.1074338573636447e+02,
                    -7.3811163431018622e+02,
                    -1.9423040703849134e-01,
                    -2.8162479047647939e+03,
                    1.3058708128015278e+03,
                    4.1632968301401644e+02,
                    -1.4478105777901037e-01,
                    -8.3699220375647587e+02,
                    4.3292265591658552e+03,
                    -1.0629207426980929e+03,
                    -2.0827312127107445e-01,
                    2.4133507436217456e+03,
                    1.6226966702011848e+03,
                    -1.1119219298778053e+03,
                    -9.3987406985359026e-02,
                    2.1202344122358086e+03,
                    -6.7470506564322041e+03,
                    2.4966246238720678e+03 },
                  { 1.5159709189408085e+02,
                    6.9957829182511091e+02,
                    -3.7721758958563761e+01,
                    9.5870186281314440e-02,
                    1.5278418461061456e+03,
                    -9.6698970157738700e+02,
                    1.0614055426837594e+03,
                    9.4759788807176851e-02,
                    -6.0952926077086659e+02,
                    -1.0629207426980956e+03,
                    3.4686704854347654e+03,
                    1.0745820150558996e-01,
                    -2.3380631323435528e+03,
                    2.1787336625789379e+02,
                    1.1633610039630564e+03,
                    3.1267725315113314e-02,
                    1.2681534551141926e+03,
                    1.1124587861924779e+03,
                    -5.6557152731230171e+03 },
                  { -3.9809552491368990e+01,
                    -3.2187326543219235e+01,
                    -4.3230036235898829e+01,
                    8.3333333333333365e-08,
                    -1.6530907461128078e+02,
                    -8.9592355204310650e+00,
                    5.7297022635646769e+01,
                    8.3333333333333365e-08,
                    7.6583672659835884e+01,
                    -1.7885510375695924e+02,
                    1.0052705887154592e+02,
                    1.6666666666666665e-07,
                    1.1639322515120497e+02,
                    5.5415417566007889e+01,
                    -5.8326099672302909e+01,
                    8.3333333333333365e-08,
                    1.2141729291608975e+01,
                    1.6458624825460166e+02,
                    -5.6267945598990948e+01 },
                  { -1.5999383815343090e+03,
                    -6.9317578157399851e-01,
                    1.1947488000874193e+03,
                    1.5100886908147412e-01,
                    2.3334426970949621e+03,
                    -2.5782644241995240e+03,
                    1.3004755912466310e+03,
                    4.0929720847498435e-02,
                    6.1335852618860472e+03,
                    2.4133507436217446e+03,
                    -2.3380631323435546e+03,
                    1.5521543513321298e-01,
                    1.1510207684779019e+04,
                    6.0114843829122560e+02,
                    -1.9121574495195168e+03,
                    1.6791384783162538e-01,
                    -1.8377297262225722e+04,
                    -4.3554158193187163e+02,
                    1.7549961905290206e+03 },
                  { -6.3182414070544183e+01,
                    -6.4892689749555598e+02,
                    1.0716947771021671e+03,
                    1.5100886908147432e-01,
                    2.3614905403215989e+03,
                    1.7128545378154906e+03,
                    -1.1558937640061561e+03,
                    1.4251702243480030e-01,
                    -2.8285232182148284e+03,
                    1.6226966702011835e+03,
                    2.1787336625789140e+02,
                    5.3628133545911352e-02,
                    6.0114843829122697e+02,
                    6.1864817635123354e+03,
                    -2.0459417649607842e+03,
                    1.6791384783162583e-01,
                    -7.0933346327453705e+01,
                    -8.8731060740334524e+03,
                    1.9122673856068816e+03 },
                  { -6.2715785002253733e+02,
                    -4.7684438133997668e+02,
                    -6.7855909888666838e+02,
                    -1.3909172423833124e-01,
                    -1.7266462431860432e+03,
                    1.7906176333350584e+02,
                    9.0995185644239905e+02,
                    -9.7023824151386898e-02,
                    1.0052723660904600e+03,
                    -1.1119219298778080e+03,
                    1.1633610039630526e+03,
                    -7.1626998754561633e-02,
                    -1.9121574495195136e+03,
                    -2.0459417649607794e+03,
                    4.1715620714176030e+03,
                    -1.4781747494503794e-01,
                    3.2606891766376357e+03,
                    3.4556463128450587e+03,
                    -5.5663158329363860e+03 },
                  { -4.1542189599019693e+01,
                    -4.5497666505486400e+01,
                    -3.3231272857648790e+01,
                    8.3333333333333378e-08,
                    -1.4948592103341460e+02,
                    7.3616469719152803e+01,
                    1.8107832127220114e-02,
                    8.3333333333333365e-08,
                    9.1425797879371586e+01,
                    -8.0255393089126869e+01,
                    3.3249380689776324e+01,
                    8.3333333333333365e-08,
                    1.3296798747839136e+02,
                    1.6461180273012604e+02,
                    -1.3288887576634150e+02,
                    1.6666666666666662e-07,
                    -3.3365674725328638e+01,
                    -1.1247521285466559e+02,
                    1.3285266010208673e+02 },
                  { 2.1135152743346716e+03,
                    8.4811107220706049e+01,
                    -2.1414441212937209e+02,
                    5.7628717276023006e-02,
                    -9.6814344757012586e+03,
                    5.7547282040476375e+00,
                    4.5062730379380719e+02,
                    2.5698696776053476e-01,
                    -1.6296654004567683e+04,
                    2.1202344122358086e+03,
                    1.2681534551141976e+03,
                    -4.7774937001370199e-02,
                    -1.8377297262225718e+04,
                    -7.0933346327456661e+01,
                    3.2606891766376361e+03,
                    -9.8568587795021173e-02,
                    4.2241870468159977e+04,
                    -2.1398669013331055e+03,
                    -4.7653255234162698e+03 },
                  { 3.5097699641845770e+02,
                    6.6764837105812933e+02,
                    -1.1012958951598193e+02,
                    5.7628717276022833e-02,
                    1.7966742715391022e+03,
                    -7.8104888726654935e+03,
                    1.7427281985154548e+03,
                    3.0187137922803014e-03,
                    4.2775721530743317e+02,
                    -6.7470506564322077e+03,
                    1.1124587861924804e+03,
                    2.0619331696688395e-01,
                    -4.3554158193187465e+02,
                    -8.8731060740334651e+03,
                    3.4556463128450614e+03,
                    -9.8568587795022408e-02,
                    -2.1398669013331200e+03,
                    2.2762997232073041e+04,
                    -6.2007037080370137e+03 },
                  { 8.8931901246515750e+01,
                    -6.8960556488409424e+01,
                    3.0001734514527197e+02,
                    5.7628717276022166e-02,
                    1.6662940817308929e+03,
                    1.8607722550464814e+03,
                    -5.6625279311459626e+03,
                    3.0187137922800980e-03,
                    1.2551033499098558e+03,
                    2.4966246238720792e+03,
                    -5.6557152731229871e+03,
                    -4.7774937001371497e-02,
                    1.7549961905290181e+03,
                    1.9122673856068700e+03,
                    -5.5663158329363778e+03,
                    1.5539966617323261e-01,
                    -4.7653255234162834e+03,
                    -6.2007037080370210e+03,
                    1.6584541692060055e+04 } };
        }


        expected_results_type<LinearAlgebraNS::type::matrix> Matrix2D()
        {
            assert(false && "Not yet implemented.");
            exit(EXIT_FAILURE);
        }


        expected_results_type<LinearAlgebraNS::type::matrix> Matrix1D()
        {
            assert(false && "Not yet implemented.");
            exit(EXIT_FAILURE);
        }


        expected_results_type<LinearAlgebraNS::type::vector> Vector3D()
        {
            return expected_results_type<LinearAlgebraNS::type::vector>{
                -1.3875785859769906e+02, 3.6044973013927813e+02,  8.2702738045948763e+02,  2.6851201306115098e+02,
                -8.0866742807868263e+02, 2.9250282912993839e+02,  1.9362146264474183e+02,  3.2550828889352249e+02,
                1.1759884583272030e+03,  -6.1542478904446318e+02, 3.1869170423448793e+02,  3.3575513675789864e+02,
                1.8182725047493514e+03,  1.0272271787250647e+03,  -8.1790521434664333e+02, 3.4751029357138742e+02,
                -2.0468356764001730e+03, -1.0647549489498178e+03, -5.2143533299207377e+02
            };
        }


        expected_results_type<LinearAlgebraNS::type::vector> Vector2D()
        {
            assert(false && "Not yet implemented.");
            exit(EXIT_FAILURE);
        }


        expected_results_type<LinearAlgebraNS::type::vector> Vector1D()
        {
            assert(false && "Not yet implemented.");
            exit(EXIT_FAILURE);
        }


    } // namespace

    // NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers,readability-function-cognitive-complexity,modernize-use-std-numbers)


} // namespace MoReFEM::TestNS::QuasiIncompressiblePk2

// NOLINTEND(cppcoreguidelines-avoid-magic-numbers,readability-magic-numbers)

// > *** MoReFEM Doxygen end of group *** //
///@} // \addtogroup TestGroup
// *** MoReFEM Doxygen end of group *** < //
